/*
A simple web server using an Arduino Wiznet Ethernet shield. 
For Arduino IDE V1.0 only. Previous IDE versions require mods to this code.

Original code created 18 Dec 2009
by David A. Mellis
modified 4 Sep 2010
by Tom Igoe
modified 18 Jan 2012
by Tim Dicus 
*/

#include <SPI.h>
#include <Ethernet.h>
#include <LiquidCrystalRus.h>


LiquidCrystalRus lcd(22, 24, 26, 28, 30, 23, 25);
// Enter a MAC address and IP address for your controller below.
// The IP address will be dependent on your local network:
byte mac[] = { 
  0xDE, 0xAD, 0xBE, 0xEF, 0xFE, 0xED };
IPAddress ip( 192,168,0,177 );
IPAddress gateway( 192,168,0,1 );
IPAddress subnet( 255,255,252,0 );
//IPAddress dns( 192,168,0,1 );

// Initialize the Ethernet server library
// with the IP address and port you want to use 
// (port 80 is default for HTTP):
EthernetServer server(80);

int i=0, n=0, z=0;
char item[255], qty[20];
void setup()
{
  Serial.begin(9600);
  lcd.begin(16, 2);

  // set SPI SS pins on w5100 and SD
  pinMode(10,OUTPUT);
  digitalWrite(10,HIGH);
  pinMode(4,OUTPUT);
  digitalWrite(4,HIGH);

  // start the SD interface here if you want.
  // Add the SD.h library above
  // SD.begin(4);

  // start the Ethernet connection and the server:
  Ethernet.begin(mac, ip);
  // disable w5100 SPI so SD SPI can work with it
  digitalWrite(10,HIGH);
  delay(2000);
  server.begin();

  Serial.println("setup finished");
  lcd.print("setup finished");
}

void loop()
{
  // listen for incoming clients
  EthernetClient client = server.available();
  if (client) {
    Serial.println("Client");
    // an http request ends with a blank line
    boolean currentLineIsBlank = true;
    while (client.connected()) {
      while(client.available()) {
        char c = client.read();
        // if you've gotten to the end of the line (received a newline
        // character) and the line is blank, the http request has ended,
        // so you can send a reply
        if (c == '\n' && currentLineIsBlank) {

// Here is where the POST data is.  
          while(client.available())
          {
            c = client.read();
            //if(c == '='){
             c = client.read();
             if(c == 'M')
             {
              n=0;
              while(n <254)
              {
               c = client.read();
               Serial.write(c);
               if(c=='&') {item[n]='\0'; break;}
               item[n] = c;
               n++;
              } 
             }
            //}
             
             if(c == 'Q')
             {
              z=0;
              while(z <19)
              {
               c = client.read();
               Serial.write(c);
               if(c=='&') {item[z]='\0'; break;}
               qty[z] = c;
               z++;
              } 
             }
            
             
             //if(i<254) {rqst[i]=c;}
             //i++;
             Serial.write(c);
          }
          Serial.println();

          Serial.println("Sending response");
          // send a standard http response header
          client.println("HTTP/1.0 200 OK");
          client.println("Content-Type: text/html");
          client.println();
          client.println("<HTML><BODY>TEST OK!");
          
          
//form added to send data from browser and view received data in serial monitor          
client.println("<FORM ACTION=\"http://192.168.0.177:80\" METHOD=\"post\">");
client.println("Name: <INPUT TYPE=\"TEXT\" NAME=\"Name\" VALUE=\"\" SIZE=\"25\" MAXLENGTH=\"50\"><BR>");
client.println("Email: <INPUT TYPE=\"TEXT\" NAME=\"Email\" VALUE=\"\" SIZE=\"25\" MAXLENGTH=\"50\"><BR>");
client.println("<INPUT TYPE=\"SUBMIT\" NAME=\"submit\" VALUE=\"Sign Me Up!\">");
client.println("</FORM>");
client.println("<BR>");
          
          client.stop();
        }
        else if (c == '\n') {
          // you're starting a new line
          currentLineIsBlank = true;
        } 
        else if (c != '\r') {
          // you've gotten a character on the current line
          currentLineIsBlank = false;
        }
      }
    }
    Serial.println("Disconnected");
  }/*
  if(i>1)
  {i=0;
   Serial.println("start");
   while(i<254)
   {
     Serial.print(rqst[i]);
     i++;
   }
   i=0;
   Serial.println("end");
  }*/
  
  if(n>0)
  {n=0;
   lcd.clear();
   Serial.print("Mess: ");
   lcd.setCursor(0, 0);
   while(n<19)
   {
     if(item[n]==0 && n!=2) { break;}
     if(item[n]=='+') {Serial.print(' '); lcd.print(' ');}
     else {
     Serial.print(item[n]); if(item[n]!=0) {lcd.print(item[n]);}}
     n++;
   }
   n=0;
   //lcd.setCursor(0, 0);
   //lcd.print(item[17], DEC);
   Serial.println();
  }
  if(z>0)
  {
   z=0;
   lcd.setCursor(0, 1);
   Serial.print("Qty:");
   lcd.print("Колличество:");
   while(z<19)
   {
     if(qty[z]==0) {break;}
     if(qty[z]=='+') {Serial.print(' ');}
     else {
     Serial.print(qty[z]);
     lcd.print(qty[z]);
     }
     z++;
   }
   z=0;
   Serial.println();
  }
}
